function [obj]=loadObj(filename)

  fileID = fopen(filename,'r');
  o=[];
  v=[];
  f=[];
  
  if fileID < 0
    error([ 'Could not open file: ' filename ]);
  else
    
      while 1    
        nline = fgetl(fileID);
        if ~ischar(nline),   break,   end   
         lineType = sscanf(nline,'%s',1); % line type 
        switch lineType
            case 'o'   % mesh vertexs
                temp=textscan(nline(2:end),'%s');
                temp=temp{1};
                o = [o; temp];
            case 'v'   % mesh vertexs
                v = [v; sscanf(nline(2:end),'%f')'];
             case 'f'   % face definition
                 temp = textscan(nline(2:end),'%s');
                 temp = temp{1};
                 
                 face=[];
                 for i=1:size(temp,1)
                     split=temp(i,1);
                     split=strsplit(split{1},'//');
                     face=[face, str2num(split{1})];
                 end
                 if size(face,2)>2
                     f = [f; face];
                 end
        end
      end
  end
  fclose(fileID);
  obj.o = o;
  obj.v = v;
  obj.f = f;
end