function obj2dataset( input1, input2, voxels, textfile)
%input1 and input2 values for grid computing, so this script can run on
%many computer in paralell.
nproc=4;

 %initialize matlabpool
if isempty(gcp('nocreate'))'
    c=parcluster('local');
    t=tempname();
    mkdir(t);
    c.JobStorageLocation=t;
    c.NumWorkers=nproc;
    if exist('parpool')
        % >= 2013b
        test=parpool(c);
    else
        % < 2013b
        test=matlabpool('local',c, c.NumWorkers);
    end
end

try
    switch nargin
    case 2
        voxels=3;%defines a voxels by voxels by voxels grid
    otherwise

        textfile='./objList.txt';%loaction of all obj one want to include into the dataset
        M = tdfread(textfile,';');
        voxels=3;%defines a voxels by voxels by voxels grid
        input1=1;
        input2=size(M,2);
    end
    

    start=input1;
    stop=input2;

    parfor x=start:stop

        inputFile=strtrim(M.inpath(x,:));
        outPut=strtrim(M.outpath(x,:));

        %load obj files
        obj=loadObj(inputFile);
        obj = objectTransform(obj,voxels,0);
        voxel=obj2voxel(obj);
        compare=load([inputFile(1:end-3) 'mat']);
        check=voxel-compare.cube;
        if max(max(max(check)))==0 & min(min(min(check)))==0
            object2frames(obj,[100 100],outPut);
            csvwrite([outPut(1:end-3) 'txt'],reshape(voxel,1,[]));
        else
            error([ 'Voxelcould incorrect: ' inputFile ]);
        end
%         clear -except start stop M voxels x ;
    end

catch e
    %do some error handling so the grid machines stay clean :)
    rethrow(e);
end
clear all;
end
