function voxel=obj2voxel(obj)
%combine vertices and faces to a single matrix
 stlcoords=[];
 parfor x=1:size(obj.f,1)
     stlcoords(x,:,:)=(obj.v(obj.f(x,1:3),:)');
 end
 if size(obj.f,2)==4
     vec=size(obj.f,1);
     parfor x=1:size(obj.f,1)        
         stlcoords(vec+x,:,:)=(obj.v(obj.f(x,2:4),:)');
     end
     clear('vec');
 end
 
offset=0.1;
offsetGrid=0.5;

maxDimX=ceil(max(max(stlcoords(:,1,:))));
maxDimY=ceil(max(max(stlcoords(:,2,:))));
maxDimZ=ceil(max(max(stlcoords(:,3,:))));
minDimX=floor(min(min(stlcoords(:,1,:))));
minDimY=floor(min(min(stlcoords(:,2,:))));
minDimZ=floor(min(min(stlcoords(:,3,:))));
stepsX=minDimX+offsetGrid:1:maxDimX;
stepsY=minDimY+offsetGrid:1:maxDimY;
stepsZ=minDimZ+offsetGrid:1:maxDimZ;

stepsCombinationsXY=CombVec(stepsX,stepsY)';
stepsCombinationsXZ=CombVec(stepsX,stepsZ)';
stepsCombinationsYZ=CombVec(stepsY,stepsZ)';

sPointZ=minDimZ-offset;
sPointY=minDimY-offset;
sPointX=minDimX-offset;

intersectionZ=[];
intersectionY=[];
intersectionX=[];

parfor iterator=1:size(stlcoords,1)
     for ori=1:size(stepsCombinationsXY,1)   
         origin = [stepsCombinationsXY(ori,:) sPointZ];
         direction = [0 0 1];
         [t, flag] = rayTriGPU(stlcoords(iterator,1,1), stlcoords(iterator,2,1), stlcoords(iterator,3,1), ...
                        stlcoords(iterator,1,2), stlcoords(iterator,2,2), stlcoords(iterator,3,2), ...
                        stlcoords(iterator,1,3), stlcoords(iterator,2,3), stlcoords(iterator,3,3), ...
                        origin(1,1), origin(1,2), origin(1,3), ...
                        direction(1,1), direction(1,2), direction(1,3));
         if flag==1
             intersection = origin + t*direction-[minDimX minDimY minDimZ-offset];
             intersectionZ=[intersectionZ; intersection];
         end
     end
    for ori=1:size(stepsCombinationsXZ,1)
        origin = [stepsCombinationsXZ(ori,1) sPointY stepsCombinationsXZ(ori,2)];
        direction = [0 1 0];
         [t, flag] = rayTriGPU(stlcoords(iterator,1,1), stlcoords(iterator,2,1), stlcoords(iterator,3,1), ...
                                stlcoords(iterator,1,2), stlcoords(iterator,2,2), stlcoords(iterator,3,2), ...
                                stlcoords(iterator,1,3), stlcoords(iterator,2,3), stlcoords(iterator,3,3), ...
                                origin(1,1), origin(1,2), origin(1,3), ...
                                direction(1,1), direction(1,2), direction(1,3));
         if flag==1 
            intersection = origin + t*direction-[minDimX minDimY-offset minDimZ];
            intersectionY=[intersectionY; intersection];
        end
    end
    for ori=1:size(stepsCombinationsYZ,1)
        origin = [sPointX stepsCombinationsYZ(ori,:)];
        direction = [1 0 0];
          [t, flag] = rayTriGPU(stlcoords(iterator,1,1), stlcoords(iterator,2,1), stlcoords(iterator,3,1), ...
                                stlcoords(iterator,1,2), stlcoords(iterator,2,2), stlcoords(iterator,3,2), ...
                                stlcoords(iterator,1,3), stlcoords(iterator,2,3), stlcoords(iterator,3,3), ...
                                origin(1,1), origin(1,2), origin(1,3), ...
                                direction(1,1), direction(1,2), direction(1,3));
        if flag==1
            intersection = origin + t*direction-[minDimX-offset minDimY minDimZ];
            intersectionX=[intersectionX; intersection];
        end
    end
end


intersectionZ=[ceil(intersectionZ(:,1)) ceil(intersectionZ(:,2)) round(intersectionZ(:,3)+1)];
intersectionY=[ceil(intersectionY(:,1)) round(intersectionY(:,2)+1) ceil(intersectionY(:,3))];
intersectionX=[round(intersectionX(:,1)+1) ceil(intersectionX(:,2)) ceil(intersectionX(:,3))];
intersectionZ=unique(intersectionZ,'rows');
intersectionY=unique(intersectionY,'rows');
intersectionX=unique(intersectionX,'rows');


 indices = find(intersectionZ(:,3)>(maxDimZ-minDimZ));
 intersectionZ(indices,:) = [];
 indices = find(intersectionY(:,2)>(maxDimY-minDimY));
 intersectionY(indices,:) = [];
 indices = find(intersectionX(:,1)>(maxDimX-minDimX));
 intersectionX(indices,:) = [];

subVoxelCloud=zeros(maxDimX-minDimX,maxDimY-minDimY,maxDimZ-minDimZ);
for idx=1:size(intersectionZ,1)
    subVoxelCloud(intersectionZ(idx,1),intersectionZ(idx,2),intersectionZ(idx,3):size(subVoxelCloud,3))=(subVoxelCloud(intersectionZ(idx,1),intersectionZ(idx,2),intersectionZ(idx,3):size(subVoxelCloud,3)))+1;
end
for idx=1:size(intersectionY,1)
    subVoxelCloud(intersectionY(idx,1),intersectionY(idx,2):size(subVoxelCloud,2),intersectionY(idx,3))=(subVoxelCloud(intersectionY(idx,1),intersectionY(idx,2):size(subVoxelCloud,2),intersectionY(idx,3)))+1;
end
for idx=1:size(intersectionX,1)
    subVoxelCloud(intersectionX(idx,1):size(subVoxelCloud,1),intersectionX(idx,2),intersectionX(idx,3))=(subVoxelCloud(intersectionX(idx,1):size(subVoxelCloud,1),intersectionX(idx,2),intersectionX(idx,3)))+1;
end
voxel=mod(subVoxelCloud,2);

end