function rstobj = objTransform(obj,maxDim,rotate)

%define roundn
roundn = @(x,n) 10.^n .* round(x/10.^n);

if nargin == 1
     maxDim = 16;
     rotate=0
end
  
if rotate ==1 
[rotmat,cornerpoints,~,~,~] = minboundbox(obj.v(:,1),obj.v(:,2),obj.v(:,3),'s',3);
else
cornerpoints=[min(obj.v(:,1)) min(obj.v(:,3)) min(obj.v(:,3));...
              max(obj.v(:,1)) max(obj.v(:,3)) max(obj.v(:,3))];
rotmat = diag([1 1 1]);
end
cornerpoints=roundn(cornerpoints,-8);
rotmat=roundn(rotmat,-8);
ranges = range(cornerpoints);
tMatrix = [1 0 0 0;... 
           0 1 0 0;...
           0 0 1 0;... 
           -(min(cornerpoints(:,1))+(ranges(1)/2))...
           -(min(cornerpoints(:,2))+(ranges(2)/2))...
           -(min(cornerpoints(:,3))+(ranges(3)/2))...
           1 ];
 
tMatrixR = [rotmat(1,:) 0;...
            rotmat(2,:) 0;...
            rotmat(3,:) 0;...
            0 0 0 1];

[maxRange,maxRangeInd] = max(ranges);
scalefactor=(maxDim/(maxRange));
tMatrixS = diag([scalefactor scalefactor scalefactor 1]);

tMatrix2 = [1 0 0 0;... 
           0 1 0 0;...
           0 0 1 0;... 
           (maxDim/2)...
           (maxDim/2)...
           (maxDim/2)...
           1 ];

T = tMatrix * tMatrixR * tMatrixS*tMatrix2;
tform = affine3d(T);
    
rstobj.v = transformPointsForward(tform,obj.v);
rstobj.f = obj.f;

end

