function bool=saveVoxels2OBJ(filename,binaryMatrix)

    cube=binaryMatrix;

    face_temp = [-8 -7 -6 -5; ...
        -1 -2 -3 -4; ...
        -5 -6 -2 -1; ...
        -4 -8 -5 -1; ...
        -4 -3 -7 -8; ...
        -7 -3 -2 -6];
    vertex=[];
    
    parfor idx = 1:numel(cube)
    [cubeX,cubeY,cubeZ] = ind2sub(size(cube),idx);
        if cube(idx)
            vertex_temp = [cubeX cubeY+1 cubeZ+1; ...
                cubeX cubeY cubeZ+1; ...
                cubeX+1 cubeY cubeZ+1; ...
                cubeX+1 cubeY+1 cubeZ+1; ...
                cubeX cubeY+1 cubeZ; ...
                cubeX cubeY cubeZ; ...
                cubeX+1 cubeY cubeZ; ...
                cubeX+1 cubeY+1 cubeZ];
            vertex=[vertex; vertex_temp-1];

        end
    end
        
    faces=[];
    vec=8:8:size(vertex,1);
    parfor x=1:size(vec,2)
        faces=[faces; face_temp+vec(x)+1];
    end
        
    %clean up
    for x=1:size(vertex,1) %merge dublicated points
        idx = ismember(vertex, vertex(x,:), 'rows');
         rows=find(idx);
         for c=2:numel(rows)
             faces( faces==rows(c) )=rows(1);
         end
     end
         
     x=1;
     while x<size(vertex,1)%del unsed vertices
         isUsed=faces( faces==x);
         if size(isUsed,1)==0
             vertex(x,:) = [];
             idx = faces > x;
             faces(idx) = faces(idx)-1;
             x=x-1;
         end
         x=x+1;
     end
% 
%     x=1;
%     while x<size(faces,1) %del faces inside the figure
%         delface=faces(x,:);
%         idx = ismember(faces, fliplr(delface), 'rows');
%         if sum(idx)==1
%             faces(find(ismember(faces, delface, 'rows')),:) = [];
%             faces(find(ismember(faces, fliplr(delface), 'rows')),:) = [];
%         end
%         x=x+1;
%     end
%     x=1;
%     while x<size(faces,1) %del faces inside the figure
%         delface=faces(x,:);
%         matchface=[faces(x,2) faces(x,1) faces(x,4) faces(x,3)];
%         idx = ismember(faces, matchface, 'rows');
%         if max(idx)==1
%             faces(find(ismember(faces, delface, 'rows')),:) = [];
%             faces(find(ismember(faces, matchface, 'rows')),:) = [];
%         end
%         x=x+1;
%     end
        
    fileID = fopen(filename,'w');
    for x=1:size(vertex,1)
        fprintf(fileID,'v %9.8f %9.8f %9.8f\n',vertex(x,1),vertex(x,2),vertex(x,3));
    end
    for x=1:size(faces,1)
        fprintf(fileID,'f %1.0f %1.0f %1.0f %1.0f\n',faces(x,1),faces(x,2),faces(x,3),faces(x,4));
    end
    fclose(fileID);
end